package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDTaskType;
import com.sa.ibiz.demo.demo.service.TSSDTaskTypeService;
import com.sa.ibiz.demo.demo.service.dto.TSSDTaskTypeSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdtasktype")
public class TSSDTaskTypeResource
{
	@Autowired
	private TSSDTaskTypeService service;


	@PostMapping(value = "/create")
	public ResponseEntity<TSSDTaskType> create(@Validated @RequestBody TSSDTaskType data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务类型[create]操作发生错误","TSSDTaskType",data.getTssdtasktypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDTaskType> remove(@Validated @RequestBody TSSDTaskType data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务类型[remove]操作发生错误","TSSDTaskType",data.getTssdtasktypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDTaskType> getDraft(@Validated @RequestBody TSSDTaskType data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务类型[getDraft]操作发生错误","TSSDTaskType","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDTaskType> checkKey(@Validated @RequestBody TSSDTaskType data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务类型[checkKey]操作发生错误","TSSDTaskType",data.getTssdtasktypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDTaskType> get(@Validated @PathVariable String id){
		TSSDTaskType data=new TSSDTaskType();
		data.setTssdtasktypeid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务调度任务类型[get]操作发生错误","TSSDTaskType",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDTaskType> update(@Validated @RequestBody TSSDTaskType data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务类型[update]操作发生错误","TSSDTaskType",data.getTssdtasktypeid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDTaskType>> searchDefaultPage(@Validated @RequestBody TSSDTaskTypeSearchFilter filter){
		Page<TSSDTaskType> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDTaskType>> listDefault(@Validated @RequestBody TSSDTaskTypeSearchFilter filter){
		List<TSSDTaskType> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
